;;; -*- Mode: Lisp; Package: FORM -*-
(in-package "FORM")  ;; creates package for abstract syntax. 

(in-package "FORM")  ;; enters package for generated code.  

(use-package '("NEWATTR" "LANG" "SB-RUNTIME" "SORT" "TERM" "OCC" "OPER" "ERGOLISP"))


(export '())

(DEFPARAMETER *FORM-OPSIG-TABLE*
              (MAKE-OPSIG-TABLE
               '((#^TUPLE .
                  #@("formtest" :=
                                                        (#t(:LIST (:SORT EXP)))
                                                        :-> #t(:SORT EXP)))
                (#^APPL .
                 #@("formtest"
                                                                      :=
                                                                      (#t(:SORT EXP)
                                                                      #t(:SORT EXP))
                                                                      :->
                                                                      #t(:SORT EXP)))
                (#^ARGS .
                 #@("formtest"
                                                                      :=
                                                                      (#t(:LIST (:SORT EXP)))
                                                                      :->
                                                                      #t(:SORT ARGS)))
                (#^IF-ELSE .
                 #@("formtest"
                                                                      :=
                                                                      (#t(:SORT EXP)
                                                                      #t(:SORT EXP)
                                                                      #t(:SORT EXP))
                                                                      :->
                                                                      #t(:SORT EXP)))
                (#^IF .
                 #@("formtest"
                                                                      :=
                                                                      (#t(:SORT EXP)
                                                                      #t(:SORT EXP))
                                                                      :->
                                                                      #t(:SORT EXP)))
                (#^PLUS .
                 #@("formtest"
                                                                      :=
                                                                      (#t(:SORT EXP)
                                                                      #t(:SORT EXP))
                                                                      :->
                                                                      #t(:SORT EXP)))
                (#^ENTRY .
                 #@("formtest"
                                                                      :=
                                                                      (#t(:SORT EXP)
                                                                      #t(:SORT EXP))
                                                                      :->
                                                                      #t(:SORT ENTRY)))
                (#^FUNCALL .
                 #@("formtest"
                                                                      :=
                                                                      (#t(:SORT SB-RUNTIME::ID)
                                                                      #t(:SORT ARGS))
                                                                      :->
                                                                      #t(:SORT EXP)))
                (#^CASE .
                 #@("formtest"
                                                                      :=
                                                                      (#t(:SORT EXP)
                                                                      #t(:SORT CHOICES))
                                                                      :->
                                                                      #t(:SORT EXP)))
                (#^ATSIGN .
                 #@("formtest"
                                                                      :=
                                                                      (#t(:SORT EXP)
                                                                      #t(:SORT EXP))
                                                                      :->
                                                                      #t(:SORT EXP)))
                (#^CHOICES .
                 #@("formtest"
                                                                      :=
                                                                      (#t(:LIST (:OP #^ENTRY)))
                                                                      :->
                                                                      #t(:SORT CHOICES)))
                (#^MULT .
                 #@("formtest"
                                                                      :=
                                                                      (#t(:SORT EXP)
                                                                      #t(:SORT EXP))
                                                                      :->
                                                                      #t(:SORT EXP)))))) 


(DEFPARAMETER *FORM-SORT-TABLE*
              (MAKE-SORT-TABLE
               '((#t(:SORT ARGS) . #t(:OP #^ARGS))
                (#t(:SORT
                                                                      CHOICES)
                 .
                 #t(:OP
                                                                      #^CHOICES))
                (#t(:SORT
                                                                      ENTRY)
                 .
                 #t(:OP
                                                                      #^ENTRY))
                (#t(:SORT
                                                                      EXP)
                 .
                 #t(:UNION
                                                                      (:OP
                                                                      #^CASE)
                                                                      (:OP
                                                                      #^IF-ELSE)
                                                                      (:OP
                                                                      #^IF)
                                                                      (:OP
                                                                      #^ATSIGN)
                                                                      (:OP
                                                                      #^MULT)
                                                                      (:OP
                                                                      #^PLUS)
                                                                      (:OP
                                                                      #^APPL)
                                                                      (:OP
                                                                      #^FUNCALL)
                                                                      (:OP
                                                                      #^TUPLE)
                                                                      (:SORT
                                                                      NUMBER)
                                                                      (:SORT
                                                                      SB-RUNTIME::ID)))))) 

(lang:lang-define 
:name "formtest"
:conc-name "form"
:code-package "FORM"
:abs-syn-package "FORM"
:use-packages '("NEWATTR" "LANG" "SB-RUNTIME" "SORT" "TERM" "OCC" "OPER" "ERGOLISP")
:sub-languages '("LEXICAL-TERMINALS")
:unparse-nts 'T
:parse-routine-name 'FORM::FORM-PARSE
:unparse-routine-name 'FORM::FORM-UNPARSE
:win-unparse-routine-name 'FORM::FORM-WIN-UNPARSE
:sort-table-name 'FORM::*FORM-SORT-TABLE*
:opsig-table-name 'FORM::*FORM-OPSIG-TABLE*
)

